﻿import es
from gamethread import delayed

info			= es.AddonInfo()
info.name		= 'New HE model + beam trace'
info.version	= '1.0'
info.url		= 'http://world-source.ru/forum/124-2572-1'
info.basename	= 'HeGrenade_Projectile'
info.author		= 'wS / Schmidt'

es.set(info.basename, info.version, 'HeGrenade_Projectile version [ Plugin by World-Source.Ru ]')
es.makepublic(info.basename)
es.set('he_model', 'models/props/cs_italy/bananna.mdl', 'Model flying combat grenades')
es.set('he_trail', '1', '1 = beam for a flying grenade, 0 = no')

def load(): es.doblock('corelib/noisy_on')
def unload(): es.doblock('corelib/noisy_off')

def weapon_fire(v):
    if v['weapon'] == 'hegrenade': delayed(.1, wS_ChangeHeModel)

def wS_ChangeHeModel():
	index = es.getentityindex('hegrenade_projectile')
	if index < 1:
		return
	# model
	wS_NewHeIndex = -1
	model = es.getString('he_model')
	if model.startswith('models') and model.endswith('.mdl'):
		wS_NewHeIndex = es.precachemodel(model.replace('\\', '/'))
	if wS_NewHeIndex > 0:
		es.setindexprop(index, 'CBaseEntity.m_nModelIndex', wS_NewHeIndex)
		es.setindexprop(index, 'CBaseEntity.m_clrRender', -1)
	# trail
	if es.getInt('he_trail') != 1:
		return
	id = es.getuserid()
	if id < 1:
		return
	trail = es.createentity('env_spritetrail')
	if trail < 1:
		return
	es.precachemodel('sprites/laser.vmt')
	BeamName = 'bm_%s' % trail
	GrenName = 'he_%s' % index
	es.entitysetvalue(index, 'targetname', GrenName)
	es.entitysetvalue(trail, 'targetname', BeamName)
	es.entitysetvalue(trail, 'spritename', 'sprites/laser.vmt')
	es.entitysetvalue(trail, 'origin', es.entitygetvalue(index, 'origin'))
	es.entitysetvalue(trail, 'rendermode', 3)
	es.entitysetvalue(trail, 'renderamt', 255);
	if es.getindexprop(index, 'CBaseEntity.m_iTeamNum') == 2:
		es.entitysetvalue(trail, 'rendercolor', '255 0 0')
	else:
		es.entitysetvalue(trail, 'rendercolor', '0 0 255')
	es.entitysetvalue(trail, 'lifetime', 2.0)
	es.entitysetvalue(trail, 'startwidth', 10.0)
	es.entitysetvalue(trail, 'endwidth', 1.0)
	es.server.queuecmd('es_xspawnentity %s;es_xfire %s %s setparent %s;es_xfire %s %s ShowSprite' % (trail, id, BeamName, GrenName, id, BeamName))

# World-Source.Ru